WAD Mangle

©2005 Ian Cowburn

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for details.

$Id: front.html,v 1.2 2005/02/20 20:56:56 ianc Exp $


GNU GENERAL PUBLIC LICENSE

Version 2, June 1991

Copyright (C) 1989, 1991 Free Software Foundation, Inc.
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users. This General Public License applies to most of the Free Software Foundation's software and to any other program whose authors commit to using it. (Some other Free Software Foundation software is covered by the GNU Library General Public License instead.) You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs; and that you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to deny you these rights or to ask you to surrender the rights. These restrictions translate to certain responsibilities for you if you distribute copies of the software, or if you modify it.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must give the recipients all the rights that you have. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

We protect your rights with two steps: (1) copyright the software, and (2) offer you this license which gives you legal permission to copy, distribute and/or modify the software.

Also, for each author's protection and ours, we want to make certain that everyone understands that there is no warranty for this free software. If the software is modified by someone else and passed on, we want its recipients to know that what they have is not the original, so that any problems introduced by others will not reflect on the original authors' reputations.

Finally, any free program is threatened constantly by software patents. We wish to avoid the danger that redistributors of a free program will individually obtain patent licenses, in effect making the program proprietary. To prevent this, we have made it clear that any patent must be licensed for everyone's free use or not licensed at all.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License applies to any program or other work which contains a notice placed by the copyright holder saying it may be distributed under the terms of this General Public License. The "Program", below, refers to any such program or work, and a "work based on the Program" means either the Program or any derivative work under copyright law: that is to say, a work containing the Program or a portion of it, either verbatim or with modifications and/or translated into another language. (Hereinafter, translation is included without limitation in the term "modification".) Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running the Program is not restricted, and the output from the Program is covered only if its contents constitute a work based on the Program (independent of having been made by running the Program). Whether that is true depends on what the Program does.

1. You may copy and distribute verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and give any other recipients of the Program a copy of this License along with the Program.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Program or any portion of it, thus forming a work based on the Program, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

  • a) You must cause the modified files to carry prominent notices stating that you changed the files and the date of any change.

  • b) You must cause any work that you distribute or publish, that in whole or in part contains or is derived from the Program or any part thereof, to be licensed as a whole at no charge to all third parties under the terms of this License.

  • c) If the modified program normally reads commands interactively when run, you must cause it, when started running for such interactive use in the most ordinary way, to print or display an announcement including an appropriate copyright notice and a notice that there is no warranty (or else, saying that you provide a warranty) and that users may redistribute the program under these conditions, and telling the user how to view a copy of this License. (Exception: if the Program itself is interactive but does not normally print such an announcement, your work based on the Program is not required to print an announcement.)
These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Program, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Program, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Program.

In addition, mere aggregation of another work not based on the Program with the Program (or with a work based on the Program) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may copy and distribute the Program (or a work based on it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you also do one of the following:

  • a) Accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

  • b) Accompany it with a written offer, valid for at least three years, to give any third party, for a charge no more than your cost of physically performing source distribution, a complete machine-readable copy of the corresponding source code, to be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

  • c) Accompany it with the information you received as to the offer to distribute corresponding source code. (This alternative is allowed only for noncommercial distribution and only if you received the program in object code or executable form with such an offer, in accord with Subsection b above.)
The source code for a work means the preferred form of the work for making modifications to it. For an executable work, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the executable. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

If distribution of executable or object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place counts as distribution of the source code, even though third parties are not compelled to copy the source along with the object code.

4. You may not copy, modify, sublicense, or distribute the Program except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense or distribute the Program is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

5. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Program or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Program (or any work based on the Program), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Program or works based on it.

6. Each time you redistribute the Program (or any work based on the Program), the recipient automatically receives a license from the original licensor to copy, distribute or modify the Program subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.

7. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Program at all. For example, if a patent license would not permit royalty-free redistribution of the Program by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system, which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

8. If the distribution and/or use of the Program is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Program under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

9. The Free Software Foundation may publish revised and/or new versions of the General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of this License, you may choose any version ever published by the Free Software Foundation.

10. If you wish to incorporate parts of the Program into other free programs whose distribution conditions are different, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs

If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.

To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively convey the exclusion of warranty; and each file should have at least the "copyright" line and a pointer to where the full notice is found.

one line to give the program's name and an idea of what it does.
Copyright (C) yyyy  name of author

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this when it starts in an interactive mode:

Gnomovision version 69, Copyright (C) year name of author
Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
type `show w'.  This is free software, and you are welcome
to redistribute it under certain conditions; type `show c'
for details.

The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of course, the commands you use may be called something other than `show w' and `show c'; they could even be mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your school, if any, to sign a "copyright disclaimer" for the program, if necessary. Here is a sample; alter the names:

Yoyodyne, Inc., hereby disclaims all copyright
interest in the program `Gnomovision'
(which makes passes at compilers) written
by James Hacker.

signature of Ty Coon, 1 April 1989
Ty Coon, President of Vice

This General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Library General Public License instead of this License.


WAD Mangle -- Introduction

Introduction

The Main Window

The main WAD Mangle window is as above. When loaded a WAD is displayed in a WAD edit window as a list of the LUMPs contained within it, listing each LUMP's names and size (in hex).

The File Menu

The File menu is used to load and save WAD files.

  • New creates a new empty WAD file.
  • Open opens an existing WAD file. A WAD file can also be opened by dragging it into the main window (NOT a WAD edit window, as this will merge the contents of the dropped WAD into the opened WAD).
  • Save saves any changes to a WAD file.
  • Save as saves any changes to a WAD file, giving it a new name.
  • Recent Files gives a quick way of loading the last 10 WAD files used.
  • Quit, err, quits.

Dragging and Dropping LUMPs

LUMPs can be selected using the standard Windows mechanisms -- left click to select, CTRL + click to select multiple items and SHIFT + click to block select a range of items. Selected items can be then be dragged about inside a WAD file, or between different WAD files.

  • LUMPs dragged to a new position in the same WAD file are moved. This can be overriden by holding down the CTRL key, which copies the LUMPs.

  • LUMPs dragged to a new position in a different WAD file are copied. This can be overriden by holding down the SHIFT key, which moves the LUMPs.

  • Files can be dragged into a WAD window. If any of the installed plugins recognise the file type then the files can be dropped and will be inserted into the WAD file.

    Note that if more that one plugin recognises the file, then the following dialog will be displayed:

    Reosolve plugin form

    For instance, a bitmap file can either be imported as a flat or a graphic (texture, sprite, etc). The list on the left lets you select the file type causing the conflict. The list in the middle simply lists the conflicting files. The list on the right is then used to decide which plugin should import the data, or whether the files should not be imported at all. Once this is completed, OK completes the drag and drop, or Cancel Drop abandons the operation.

  • Note: By default when dropping a LUMP it is inserted in front of the LUMP over which the mouse button was released, or appended at the end of the WAD end if not released over an existing LUMP.

    Tip: To save the hassle of having to scroll right to the end of a large WAD file, releasing the button over the empty column to the right of the 'Length' column has the same affect as if the button was not released over an existing LUMP.

Manipulating LUMPs

Once LUMPs have been selected, clicking the right mouse button brings up a context menu that allows the selected LUMPs and the WAD to be maninipulated.

  • Edit Lump allows the selected LUMP to be edited. See Provided Plugins for details as to what can be edited.

  • View Lump allows the selected LUMP to be viewed. See Provided Plugins for details as to what can be viewed.

  • Import Lumps allows the files to imported and inserted in front of the selected LUMP. Importing a LUMP is the same as dragging a file into the WAD window. See Provided Plugins for details as to what can be imported.

  • Export Lumps allows the LUMPS to be exported to the appropriate formatted files (eg. bitmaps for graphics). See Provided Plugins for details as to what can be exported.

  • Edit WAD edits the WAD as an whole (for instance, ZDOOM textures). See Provided Plugins for details.

  • New Lump inserts a new zero-length LUMP once you have provided a name.

  • Rename renames the selected LUMP.

  • Search searches for a LUMP that matches the provided regular expression. If found the LUMP is shown and selected.

  • Delete removes the selected LUMPs from the WAD file.

$Id: introduction.html,v 1.5 2005/02/21 00:47:09 ianc Exp $


WAD Mangle -- Tools, Config and Plugin Control

Tools, Config and Plugin Control

About Plugins

WAD Mangle allows various tools that manipulate edited LUMPs and WADs, or even completely seperate tools, to be provided in the form of plugins. Plugins can be distributed as .NET assembly DLLs, and added to WAD Mangle using the Plugin Control.

You can see what Plugins are available using the About option on the Help menu, as illustrated here:

A basic set of plugins (probably more than enough for most WAD manipulation uses) are bundled with WAD Mangle.

WAD Packager

WAD Package is a tool that actually does nothing to any of the loaded WAD files. It is selected from the Tool menu.

Its intended use is to package up multiple WADs (for instance, all the levels you wish to put in a single WAD file), along with an easy way to define a MAPINFO LUMP and title, inter-level and end-screen pictures:

  • At the top of the WAD Package window you can add and remove WAD files which will be bundled up into into the output WAD.

  • If you wish you can include a MAPINFO LUMP by selecting the checkbox and edit the MAPINFO using the button on the left.

  • The next three checkboxes and buttons allow you to select a BMP file to use as the title screen, inter-level screen and cast-list backdrops used in DOOM II.

  • Below these you can select the output WAD all these items will be bundled up into.

  • The bottom row of buttons allows you to reset the fields to their intial state (New), Load and Save the package. Just the paths to the selected files and the MAPINFO contents are saved -- not the contents of the selected files.

  • Finally, the Build button generates the selected output WAD file.

  • Note: Bitmaps must be 8-bits deep, and should be 320x200 pixels in size.

    Tip: Remember the selected WADs don't have to just contain levels you wish to bundle up -- in the example above it's also been used to bundle in a WAD file (graphics.wad) holding custom textures for the levels.

Configuration

The way WAD Mangle works can be altered by selecting the Options... item in the Tools menu.

  • When dropping items into a WAD
    This option decides where LUMPs will be dropped during a drag and drop operation. The choices are to drop where the button is released, to always drop LUMPs at the end of the WAD or to ask using a popup menu whether the LUMPs should be dropped here or at the end.

  • Confirm deletion of lumps
    Controls whether confirmation is asked before LUMPs are deleted.

  • Confirm Close/Exit ...
    Decides whether confirmation is asked when closing WAD files that have been edited. This option applies to both closing individual WAD edit windows, and WAD Mangle itself.

  • Always show resolve dialog ...
    Allows you to always display the Resolve Dialog when dropping LUMPs. See Dragging and Dropping Lumps for more details.

  • Double click renames lump
    If checked then double clicking on a LUMP in the WAD edit window renames the LUMP.

  • Double clicking activates viewer
    If the previous option hasn't been checked, then you can control which plugin will be used to view a LUMP when it is double clicked.

Plugin Control

The plugins available in WAD Mangle works can be altered by selecting the Plugin Control option in the Tools menu. The following dialog will be displayed:

  • The Add... and Remove buttons allows the list of DLLs in the left hand pane to be altered. Selecting a DLL will display the services it provides in the right hand pane.

  • Use OK and Cancel to complete or cancel your changes.

  • Note: Changes will not take affect until WAD Mangle is restarted.

$Id: tool.html,v 1.5 2005/02/21 00:47:09 ianc Exp $


WAD Mangle -- Provided Plugins

Provided Plugins

ASCII

  • This plugin manipulates LUMPs that contain ASCII data. These are mainly used by ZDoom (see the ZDoom WIKI), which has a number of LUMP types containing ASCII.

  • ASCII LUMPs can be:

    • Edited
    • Viewed
    • Exported
    • Imported

  • ASCII LUMPs can be dragged in as files with an extension of .txt

BINARY

  • This plugin manipulates LUMPs that contain binary data. Which basically means any LUMP.

  • Binary LUMPs can be:

    • Viewed
    • Exported
    • Imported

  • Binary LUMPs can be dragged in as files with an extension of .bin

Graphics (DOOM Graphics format)

  • This plugin manipulates LUMPs that contain graphical data in the normal DOOM format. This includes textures, sprites, screens and so on (basically everything graphical aside from FLATs).

  • Graphic LUMPs can be:

    • Viewed
    • Exported
    • Imported
    • Edited

  • When Graphic LUMPs are imported or dragged into a WAD they are given a default offset of width/2+1 and height-5. .bmp

  • Graphic LUMPs can be dragged in as files with an extension of bmp, png, gif or jpg. Due to the lossy nature of JPEG it is not recommended that it is used if avoidable.

  • When editing a grahpcial LUMP the following dialog is displayed:

    Which allows you to set the offset of a graphic and whether it is positioned relatively or absolutely. By pressing the Centre button you can centre the offsets, either to the screen for absolute positioning or using the general wall patch offset of width/2+1 and height-5. Note that the offsets can be entered manually or by dragging the graphic around in the preview.

  • Note: See the Bitmap Formats for important information on the formats available for exporting and importing bitmaps.

Graphics (FLAT format)

  • This plugin manipulates LUMPs that contain graphical data in the FLAT format. This is the format used for the textures that adorn the floors and ceilings in DOOM. Note that flat sizes of 64x64, 128x128 and 256x256 are supported by WAD Mangle.

  • FLAT LUMPs can be:

    • Viewed
    • Exported
    • Imported

  • FLAT LUMPs can be dragged in as files with an extension of bmp, png, gif or jpg. Due to the lossy nature of JPEG it is not recommended that it is used if avoidable.

  • Note: See the Bitmap Formats for important information on the formats available for exporting and importing bitmaps.

WAD Files

  • This plugin allows WAD files to be inserted and extracted from the WAD file being edited.

  • WADs can be:

    • Exported
    • Imported

  • WADs can be dragged in as files with an extension of .wad

WAV Sample

  • This plugin manipulates LUMPs that contain sound (sample) data.

  • This plugin only lets you export LUMPs that begin with the characters 'DS'. This is the way DOOM marked sample LUMPs, but as ZDoom allows any LUMP be contain sample data, this restriction may be removed in future releases.

  • WAV files can be:

    • Exported
    • Imported

  • WAV samples can be dragged in as files with an extension of .wav

ZDOOM Flats

  • This plugin does not manipulate individual lumps, but the WAD file has an whole. ZDoom allows the easy inclusion of custom FLAT LUMPs be surrounding them with FF_START and FF_END lumps.

  • The FLATs are listed on the left hand side, and can be manipulated using the Add..., Rename and Remove buttons.

  • The left hand side of the dialog shows the FLAT currently selected. The Select Bitmap button can be used to replace the graphics of the currently selected FLAT.

  • Note: See the Bitmap Formats for important information on the formats available for exporting and importing bitmaps.

  • Note: If changes are OK'ed, then the orignal LUMPs are removed from the edited WAD and the new set appended at the end of the WAD file.

ZDOOM Textures

  • This plugin does not manipulate individual lumps, but the WAD file has an whole. ZDoom allows the easy inclusion of custom DOOM format graphic LUMPs be surrounding them with TX_START and TX_END lumps.

  • The graphics are listed on the left hand side, and can be manipulated using the Add..., Rename and Remove buttons.

  • The right hand side of the dialog shows the graphic currently selected. The Select Bitmap button can be used to replace the currently selected graphic.

  • Note: See the Bitmap Formats for important information on the formats available for exporting and importing bitmaps.

  • Note: If changes are OK'ed, then the orignal LUMPs are removed from the edited WAD and the new set appended at the end of the WAD file.

DOOM Wall Patchs (PNAMES lump)

  • This plugin allows you to edit the PNAMES lump as used to define wall patches in the original DOOM. If you are unsure how wall patches work in DOOM, the ZDOOM Wiki has a good entry on them.

  • The wall patches are listed on the left hand side. Each listed patch is a lump in DOOM Graphics Format. The list can be manipulated using the Add, Insert, Remove and Change buttons.

  • The right hand side of the dialog shows the graphic currently selected.

  • REALLY IMPORTANT: The order of entries in the PNAMES lump affects the way that the TEXTURE lumps work in DOOM. If you delete entries from the middle of the list then the TEXTURE lump will be undoubtedly broken. Always finalise PNAMES before editing textures, or only add new wall patches once texture editing has begun.

DOOM Textures (TEXTURE lumps)

  • This plugin allows you to edit the TEXTURE lumps (usually called TEXTURE1 and TEXTURE2) as used to define wall textures in the original DOOM. This editor may not make a total amount of sense unless you have some prior knowledge how DOOM handles textures. The ZDOOM Wiki has a good entry on them.

  • The texture names are listed on the left hand side. The list can be manipulated using the Add, Insert, Remove and Change buttons. Below these buttons are fields where the width and height of the texture can be altered. The Recalc buttons can be used to set these from the locations occupied by wall patches.

  • In the upper middle of the dialog are listed the wall patches that make up the texture. Below it patches can be added and removed from the texture with the Add Patch and Remove buttons. Below these buttons the offset of the wall patch can be changed. Also notice the white border in the texture preview? This shows the currently selected wall patch and can be dragged with the left mouse button as an alternative to entering the numbers directly.

  • In the lower middle of the dialog the patches defined in the PNAMES lump are listed. Select patches to be added to the texture with this list. Note that at the far right is a checkbox marked Track Selected Patch. If this is selected then the patch name is automatically selected to match the selected wall patch in the texture.

  • Finally there is the usual OK and Cancel buttons. Also there is a button Export Textures that allows all the textures in the lump to be output to a directory.

$Id: plugins.html,v 1.5 2005/05/31 00:10:16 ianc Exp $


Bitmap Formats

Bitmap Exports

In the provided plugins all bitmaps are exported by default as PNG files with 24-bit colour and an alpha channel for the transparency.

This can be overwridden when exporting individual lumps, but note that transparency information will be lost if exported as other file types.

Also note that if exported as a GIF then .NET will try and reduce the generated 32-bit image (all images are manipulated as 32-bits inside WADMangle) to a paletted 8-bit image. It makes a real mess of this, so don't bother.

Bitmap Imports

When importing bitmaps different things will happen depending on the depth and format of the file.

8-bit indexed formats

These rules apply to 8-bit bmp, png and gif files.

When importing 8 bit files then the colours are expected to be drawn in the same palette as defined in the currently loaded WAD files, or the default DOOM II palette if no PLAYPAL lump is found.

Transparency: While technically it is incorrect, files in this format are process assuming that colour 247 is transparent to maintain consistency with other DOOM WAD manipulation tools.

24-bit formats

These rules apply to 24-bit bmp, png and jpg files. Note that JPEG is not recommended for importing hand drawn textures as it is a lossy format.

When importing true colour files then the colours in the bitmap are matched to the closest matching colour in the palette as defined in the currently loaded WAD files, or the default DOOM II palette if no PLAYPAL lump is found.

Transparency: Transparency cannot be used with this format.

32-bit (alpha) formats

These rules apply to 32-bit png files.

When importing true colour files then the colours in the bitmap are matched to the closest matching colour in the palette as defined in the currently loaded WAD files, or the default DOOM II palette if no PLAYPAL lump is found.

Transparency: Transparency is supported through the alpha channel. Any pixels with an alpha of zero are considered transparent.

$Id: bitmaps.html,v 1.1 2005/05/31 00:10:17 ianc Exp $


WAD Mangle -- Writing your own plugin

Writing your own plugin

This section assumes you understand .NET, assembly files, C# and have found your way around the WAD Mangle sources. It's probably not as detailed as it could be either.

Overview

WAD Mangle plugins are simply .NET DLLs that implement the interface WADMangle.Plugin.IPlugin.

To make plugin writing even easier a base plugin (WADMangle.Plugin.BasePlugin) has been implemented that provides a skeleton plugin that support nothing and provides default 'do nothing' implementations for all the required interfaces.

It is strongly recommended to base your plugin from this class, rather than the interface directly, as then you can omit meaningless members from the plugin itself.

Look in the namespace WADMangle.DOOM for all the classes relating to the WAD files and LUMPs (which I called WADEntry for bizarre reason) themselves.

Programmer Documentation

MSDN style documentation for the crucial namespaces can be viewed here.

$Id: author.html,v 1.2 2005/02/20 20:56:56 ianc Exp $


WAD Mangle -- Glossary

Glossary

While a basic knowledge of DOOM and WAD file formats is needed to fully utilise WADMangle, a general description is provided here.

DOOM

An exciting new game featuring realistic high-resolution 3D graphics and utilising every last drop of power in the Intel 486 processor.

So, yes it is old, but then so is Super Locomotive and I still play that.

WAD

A WAD File is a specially formated file that DOOM uses to store level, graphics and sound data. A WAD file is split into a series of LUMPs.

WAD files come in two forms. An IWAD is the 'internal' WAD provided by id Software (eg. doom.wad). A PWAD is a 'patch' WAD file. These PWAD files can contain user-defined levels for instance, and entries in these patch WADs override the entries in the internal WAD file.

LUMP

A LUMP is simply a block of binary data, given a name. There is no different 'level' or 'sound' type lumps (ie. all LUMPs are identical in basic format). DOOM simply gives meaning to a LUMP's contents depending on where it is in the WAD, which other special marker LUMPs enclose it or what it is called.

For instance, DOOM will search the WAD files it has loaded for a LUMP called TITLEPIC. This lump will be decoded as a graphic and displayed as the title picture on loading DOOM. Likewise, a LUMP whose name starts with the characters DS will be treated as containing sample (sound) data.

Note that in the original DOOM the meaning given to special LUMPs, and where graphical LUMPs could be stored (to replace textures in the game for instance) was pretty messy. Recent source ports of DOOM, like ZDoom have a much more relaxed attitude towards such things, and unless compatibility with the original DOOM or DOOM II is required should be used in preference.

ZDoom

My preferred weapon of choice while developing WAD Mangle.

Play MAP32 from Plutonia in it, with a large hi-res screen, all the wall decals from weapon hits, particles from the Cyberdemons missles swirling around your head...

Now tell me your heart doesn't sing even while it's being picked over by the ravenous Legions of Hell...

$Id: glossary.html,v 1.5 2005/05/28 01:43:58 ianc Exp $